Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestPrint/FrmRequestPrintSelAux.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestPrint/FrmRequestPrintSelAux.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestPrint/FrmRequestPrintSelAux.cs	(revision 369)
@@ -0,0 +1,1313 @@
+﻿using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Threading;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+
+using ProcessManagement.Common;
+using ProcessManagement.DataModel;
+using ProcessManagement.DB;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.Forms.SubForms;
+using ProcessManagement.Forms.ControlsAction;
+
+
+namespace ProcessManagement.Forms.DataEntry
+{
+    public partial class FrmRequestPrintSel
+    {
+        #region フォームの初期スタイル設定
+        /// <summary>
+        /// フォームの初期スタイル設定
+        /// </summary>
+        private void InitSetFormStyle()
+        {
+            try
+            {
+                dgv1.EnableHeadersVisualStyles = false;
+                dgv1.AutoGenerateColumns = false;
+                dgv1.ColumnHeadersHeight = 28;
+                dgv1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
+                dgv1.AllowUserToAddRows = false;
+                dgv1.RowTemplate.Height = 24;
+                dgv1.Font = new System.Drawing.Font("ＭＳ 明朝", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
+                dgv1.ColumnHeadersDefaultCellStyle.BackColor = Color.Aquamarine;
+
+                int yyyy = CommonMotions.cnvTruncate((double)m_nRequestMonth / 100);
+                int mm = m_nRequestMonth % 100;
+                lbReqMonth.Text = string.Format("{0}/{1}", yyyy, mm.ToString("D2"));
+                lbOrderersName.Text = m_strOrderersName;
+
+                string strSubTitle = string.Empty;
+                switch (m_ExecuteSubFlg)
+                {
+                    case (int)ConstructionBaseInfo.BillingSplitFlgDef.SplitBilling:
+                        strSubTitle = "出来高　分割";
+                        break;
+                    case (int)ConstructionBaseInfo.BillingSplitFlgDef.AllOnBilling:
+                        strSubTitle = "完了後　一括";
+                        break;
+                }
+                // 処理名称表示
+                lblProcessTitil.Text = string.Format("{0}　【{1}】", ClsExcute.ProcessExecuteName[m_ExecuteFlg].Replace("－", ""), strSubTitle);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region データ表示
+        /// <summary>
+        /// データ表示
+        /// </summary>
+        private void DispGridData()
+        {
+            // 請求書データ取得
+            GetInvData();
+
+            // 請求データ取得
+            GetReqestData();
+
+            // 請求データ表示
+            DispRequestData();
+
+            // チェックより金額計算
+            UpdateCheckValue();
+        }
+        #endregion
+
+        #region 選択数、選択金額の更新
+        /// <summary>
+        /// 選択数、選択金額の更新
+        /// </summary>
+        void UpdateCheckValue()
+        {
+            try
+            {
+                int cnt = 0;
+                long val;
+                long amount = 0;
+                foreach (DataGridViewRow CurRow in dgv1.Rows)
+                {
+                    bool bCurRowChk = CommonMotions.cnvBool(CurRow.Cells[(int)DispColumn.CheckFlg].Value);
+                    if (!bCurRowChk) continue;
+
+                    cnt++;
+
+                    val = CommonMotions.cnvLong(CurRow.Cells[(int)DispColumn.ReqValue].Value);
+
+                    amount += val;
+                }
+
+                lbSelect.Text = cnt.ToString("#,0");
+                lbTotalAmount.Text = amount.ToString("#,0");
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 請求書データの取得
+        /// <summary>
+        /// 請求書データの取得
+        /// </summary>
+        private void GetInvData()
+        {
+            IOInvoiceData ioInvData = new IOInvoiceData();
+            try
+            {
+                StringBuilder sql = new StringBuilder();
+                sql.Append(" As InvData");
+                sql.AppendFormat(" WHERE InvData.OrderersDivision = {0}", m_nOrderersDivision);
+                sql.AppendFormat(" AND InvData.OrderersCode = {0} ", m_nOrderersCode);
+                sql.AppendFormat(" AND InvData.RequestMonth = {0} ", m_nRequestMonth);
+                sql.AppendFormat(" AND InvData.COMPLETEFLG > {0}", (int)InvoiceData.CompleteFlgDef.Deleted);
+                sql.Append("       AND EXISTS( SELECT * FROM RequestHead ReqHead WHERE ReqHead.InvoiceNo = InvData.InvoiceNo )");
+                sql.Append(" ORDER BY InvData.CretateDate Asc, InvData.SeqNo Asc");
+
+                List<InvoiceData> InvoiceList = new List<InvoiceData>();
+                // SQL実行
+                if (!ioInvData.SelectAction(sql.ToString(), ref InvoiceList)) return;
+
+                // データセット
+                m_dicInvData.Clear();
+                foreach(InvoiceData work in InvoiceList)
+                {
+                    m_dicInvData.Add(work.InvoiceNo, work);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                ioInvData.close();
+                ioInvData = null;
+            }
+            return;
+        }
+        #endregion
+
+        #region 請求データの取得
+        /// <summary>
+        /// 請求データの取得
+        /// </summary>
+        private void GetReqestData()
+        {
+            IORequestHead ioReqHead = new IORequestHead();
+
+            try
+            {
+                StringBuilder sql = new StringBuilder();
+                sql.Append("Select A.* From RequestHead As A");
+                sql.Append("           Inner Join processapproval As B");
+                sql.Append("                  On B.ConstructionCode = A.REQCONSTRUCTIONCODE");
+                sql.AppendFormat("            And B.ApprovalCode = {0}", (int)ClsExcute.ApprovalListNo.OrderRequestApproval);
+                sql.Append("                  And B.OrderNo = A.ORDERNO");
+                sql.AppendFormat("            And B.SeqNo = {0}", CommonDefine.s_Default_OrderNo);
+                sql.AppendFormat("            And B.ApprovalStatus = {0}", (int)CommonDefine.ApprovalStatus.Approval);
+                sql.AppendFormat("     Where A.RequestMonth = {0}", m_nRequestMonth);
+                sql.AppendFormat("     And A.OrderersDivision = {0}", m_nOrderersDivision);
+                sql.AppendFormat("     And A.OrderersCode = {0}", m_nOrderersCode);
+                sql.Append(" Group By A.REQUESTNO");
+                sql.Append(" Order by A.INVOICENO ASC, A.REQUESTNO ASC, A.ReqConstructionCode Asc, a.OrderNo Asc");
+
+                ArrayList lstWork = new ArrayList();
+                if (!ioReqHead.ExecuteReader(sql.ToString(), ref lstWork)) return;
+
+                m_lstReqHead.Clear();
+                foreach (object[] objRec in lstWork)
+                {
+                    RequestHead ReqHead = new RequestHead();
+                    ioReqHead.Reader2Struct(objRec, ref ReqHead);
+
+                    // 請求ヘッダの追加
+                    m_lstReqHead.Add(ReqHead);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                ioReqHead.close(); ioReqHead = null;
+            }
+        }
+        #endregion
+
+        #region 請求データの表示
+        /// <summary>
+        /// 請求データの表示
+        /// </summary>
+        private void DispRequestData()
+        {
+            try
+            {
+                dgv1.Rows.Clear();
+                int BreakKey = m_lstReqHead[0].InvoiceNo;
+                int nDataCnt = 0;
+                foreach (RequestHead ReqHead in m_lstReqHead)
+                {
+                    // 請求書番号が違えば1行空ける
+                    if (BreakKey != ReqHead.InvoiceNo)
+                    {
+                        int BrankRow = dgv1.Rows.Add(1);
+                        BreakKey = ReqHead.InvoiceNo;
+                        dgv1.Rows[BrankRow].Cells[(int)DispColumn.CheckFlg].ReadOnly = true;
+                        dgv1.Rows[BrankRow].Cells[(int)DispColumn.CheckFlg].Style.BackColor = Color.White;
+                        dgv1.Rows[BrankRow].Cells[(int)DispColumn.CheckFlg].Style.ForeColor = Color.White;
+                    }
+
+                    // 行を追加
+                    int trow = dgv1.Rows.Add(1);
+                    DataGridViewRow CurRow = dgv1.Rows[trow];
+                    CurRow.Cells[(int)DispColumn.CheckFlg].ReadOnly = false;
+                    CurRow.Cells[(int)DispColumn.DataNo].Value = ++nDataCnt;
+
+                    string strConstrName = ReqHead.ReqConstructionName;
+                    if (m_ExecuteSubFlg == (int)ConstructionBaseInfo.BillingSplitFlgDef.SplitBilling)
+                    {
+                        strConstrName = string.Format("{0}：{1}回目", ReqHead.ReqConstructionName, ReqHead.OrderNo);
+                    }
+                    CurRow.Cells[(int)DispColumn.RequestTitle].Value = strConstrName;
+                    CurRow.Cells[(int)DispColumn.ReqValue].Value = ReqHead.RequestAmount.ToString("#,0");
+                    CurRow.Cells[(int)DispColumn.RequestNo].Value = ReqHead.RequestNo;
+
+                    // 印刷未は以下を処理しない
+                    if (ReqHead.InvoiceNo < 1) continue;
+
+                    InvoiceData InvData = null;
+                    if (!m_dicInvData.TryGetValue(ReqHead.InvoiceNo, out InvData)) continue;
+
+                    // データセット
+                    CurRow.Cells[(int)DispColumn.CreateDate].Value = InvData.CretateDate.ToString("yyyy/MM/dd");
+                    CurRow.Cells[(int)DispColumn.InvoiceNo].Value = InvData.InvoiceNo;
+                    // 印刷済みは背景色を変える
+                    foreach (DataGridViewCell CurCell in CurRow.Cells)
+                    {
+                        CurCell.Style.BackColor = Color.LightGray;
+                    }
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                // グリッド一杯の行が16行
+                int nStRow = dgv1.RowCount;
+                if (nStRow < 16) {
+                    dgv1.RowCount = 16;
+                    for (int i = nStRow; i < 16; i++)
+                    {
+                        dgv1.Rows[i].Cells[(int)DispColumn.CheckFlg].ReadOnly = true;
+                    }
+                }
+                btnDel.Enabled = false;
+                btnGenerate.Enabled = false;
+            }
+        }
+        #endregion
+
+        #region 作成チェック
+        /// <summary>
+        /// 作成チェック
+        /// </summary>
+        /// <param name="msg"></param>
+        /// <returns></returns>
+        private int CheckGenerate(ref string msg)
+        {
+            try
+            {
+                int nRet = (int)CheckState.Ok;
+
+                // 選択なし
+                int nSelect = CommonMotions.cnvInt(lbSelect.Text);
+                if (nSelect < 1)
+                {
+                    msg = "請求件名が選択されていません。";
+                    return (int)CheckState.Error;
+                }
+
+                // 請求書番号つきデータの複数選択チェック
+                if (!BillingNoMulitiCheck())
+                {
+                    msg = "印刷済みの請求書を含めて複数選択しています。\r\n続行するには先に請求取消をしてください。";
+                    return (int)CheckState.Error;
+                }
+
+                //int nInvoiceNo = GetSelInvoiceNo();
+
+                //foreach (DataGridViewRow CurRow in dgv1.Rows)1
+                //{
+                //    // 請求ヘッダが紐づいていない行はダミー
+                //    if (CommonMotions.cnvInt(CurRow.Cells[(int)DispColumn.RequestNo].Value) < 1) break;
+
+                //    if (!CurRow.Cells[(int)DispColumn.CheckFlg].EditedFormattedValue.Equals(true)) continue;
+
+                //    if (CommonMotions.cnvInt(CurRow.Cells[(int)DispColumn.InvoiceNo].Value) < 1) continue;
+
+                //    // 選択されている場合
+                //    if (CommonMotions.cnvInt(CurRow.Cells[(int)DispColumn.InvoiceNo].Value) != nInvoiceNo)
+                //    {
+                //        nRet = (int)CheckState.Warning;
+                //        break;
+                //    }
+                //}
+
+                //if (nRet == (int)CheckState.Warning)
+                //{
+                //    msg = "他で請求されている請求件名が選択されています。\r\nこの内容で請求書を作成してよろしいですか？";
+                //    return nRet;
+                //}
+
+                //foreach (DataGridViewRow CurRow in dgv1.Rows)
+                //{
+                //    // 請求ヘッダが紐づいていない行はダミー
+                //    if (CommonMotions.cnvInt(CurRow.Cells[(int)DispColumn.RequestNo].Value) < 1) break;
+
+                //    // 選択されている場合
+                //    if (!CurRow.Cells[(int)DispColumn.CheckFlg].EditedFormattedValue.Equals(true)) continue;
+
+                //    if (CommonMotions.cnvInt(CurRow.Cells[(int)DispColumn.InvoiceNo].Value) > 0) continue;
+
+                //    if (nInvoiceNo == 0)
+                //    {
+                //        msg = "既に作成済の請求書に新規請求件名を追加します。\r\nこの内容で請求書を作成してよろしいですか？";
+                //        nRet = (int)CheckState.Warning;
+                //        break;
+                //    }
+                //}
+
+                if (nRet == (int)CheckState.Ok)
+                {
+                    msg = "この内容で請求書を作成してよろしいですか？";
+                }
+
+                return nRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return (int)CheckState.Error;
+            }
+        }
+        #endregion
+
+        #region 請求書データ登録
+        /// <summary>
+        /// 請求書データ登録
+        /// </summary>
+        /// <returns></returns>
+        private bool EntryPrintData(IOInvoiceData ioInvData, IORequestHead ioReqHead, string[] CommentData)
+        {
+            try
+            {
+                int nInvoiceNo = GetSelInvoiceNo();
+
+                List<RequestHead> lstReqHead = new List<RequestHead>();
+
+                foreach (DataGridViewRow CurRow in dgv1.Rows)
+                {
+                    // 請求ヘッダが紐づいていない行はダミー
+                    if (CommonMotions.cnvInt(CurRow.Cells[(int)DispColumn.RequestNo].Value) < 1) continue;
+
+                    // 選択されていない場合
+                    if (!CurRow.Cells[(int)DispColumn.CheckFlg].EditedFormattedValue.Equals(true)) continue;
+
+                    // 対象データ追加
+                    int nIndex = CommonMotions.cnvInt(CurRow.Cells[(int)DispColumn.DataNo].Value) - 1;
+                    lstReqHead.Add(m_lstReqHead[nIndex]);
+                }
+
+                // 請求書データの登録
+                if(!AddInvoiceData2(ioInvData, ioReqHead, lstReqHead, CommentData, ref nInvoiceNo))
+                {
+                    MessageBox.Show("請求書データ登録エラー","登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 請求書データの登録
+        /// <summary>
+        /// 請求書データの登録
+        /// </summary>
+        /// <returns></returns>
+        private bool AddInvoiceData2(IOInvoiceData ioInvData
+                                    , IORequestHead ioReqHead
+                                    , List<RequestHead> lstReqHead
+                                    , string[] CommentData
+                                    , ref int nInvoiceNo)
+        {
+            try
+            {
+                // 請求書Noが指定されていない場合
+                bool bExistsInvoice = true;
+                if (nInvoiceNo == 0)
+                {
+                    // 請求書Noの採番
+                    nInvoiceNo = ioInvData.NumberingInvoiceNo(m_nRequestMonth, false);
+                    if (nInvoiceNo < 0) return false;
+                    bExistsInvoice = false;
+                }
+                m_nInvoiceNo = nInvoiceNo;
+
+                // 選択されている請求ヘッダの請求書Noを更新
+                StringBuilder strSQL = new StringBuilder();
+                strSQL.Append("Update RequestHead");
+                strSQL.AppendFormat(" Set INVOICENO = {0}", nInvoiceNo);
+                strSQL.Append(" Where REQUESTNO in (");
+                bool bFirst = true;
+                foreach (RequestHead ReqHead in lstReqHead)
+                {
+                    if (!bFirst) strSQL.Append(",");
+                    strSQL.AppendFormat("{0}", ReqHead.RequestNo);
+                    bFirst = false;
+                }
+                strSQL.Append(")");
+                if (!ioReqHead.ExecuteNonQuery(strSQL.ToString(), false)) return false;
+
+                // 請求ヘッダより請求金額を取得する
+                strSQL.Clear();
+                strSQL.Append("Select INVOICENO, SUM(REQUESTAMOUNT), Sum(TAXAMOUNT) From RequestHead");
+                strSQL.AppendFormat(" Where INVOICENO = {0}", nInvoiceNo);
+                strSQL.Append(" Group By INVOICENO");
+                ArrayList GetList = new ArrayList();
+                if (!ioReqHead.ExecuteReader(strSQL.ToString(), ref GetList, false)) return false;
+                if (GetList.Count < 1) return false;
+
+                object[] objRec = (object[])GetList[0];
+                m_lTotalAmount = CommonMotions.cnvLong(objRec[1]);
+                m_lTaxAmount = CommonMotions.cnvLong(objRec[2]);
+
+                // 請求書Noが指定されていない場合
+                if (!bExistsInvoice)
+                {
+                    // 請求書データ構築
+                    InvoiceData InvData = new InvoiceData();
+
+                    InvData.InvoiceNo = nInvoiceNo;
+                    InvData.OrderersDivision = m_nOrderersDivision;
+                    InvData.OrderersCode = m_nOrderersCode;
+                    InvData.RequestMonth = m_nRequestMonth;
+                    InvData.SeqNo = ioInvData.NumberingSeqNo(m_nOrderersDivision, m_nOrderersCode, m_nRequestMonth, false);
+                    InvData.CretateDate = DateTime.Now;
+                    InvData.RequestDate = m_DatePrintOut;
+                    InvData.RequestName = m_strOrderersName;
+                    InvData.TotalAmount = m_lTotalAmount;
+                    InvData.TaxAmount = m_lTaxAmount;
+                    InvData.Comment1 = CommentData[0];
+                    InvData.Comment2 = CommentData[1];
+                    InvData.Comment3 = CommentData[2];
+                    InvData.Comment4 = CommentData[3];
+                    InvData.Comment5 = CommentData[4];
+                    InvData.CompleteFlg = (int)InvoiceData.CompleteFlgDef.Printed;
+
+                    // 請求書データの挿入
+                    if (!ioInvData.InsertAction(InvData, false)) return false;
+                }
+                else
+                {
+                    // 請求書データの取得
+                    InvoiceData InvData = new InvoiceData();
+                    strSQL.Clear();
+                    strSQL.Append(ioInvData.CreatePrimarykeyString(nInvoiceNo));
+                    if (!ioInvData.SelectAction(strSQL.ToString(), ref InvData, false)) return false;
+
+                    InvData.RequestDate = m_DatePrintOut;
+                    InvData.RequestName = m_strOrderersName;
+                    InvData.TotalAmount = m_lTotalAmount;
+                    InvData.TaxAmount = m_lTaxAmount;
+                    InvData.Comment1 = CommentData[0];
+                    InvData.Comment2 = CommentData[1];
+                    InvData.Comment3 = CommentData[2];
+                    InvData.Comment4 = CommentData[3];
+                    InvData.Comment5 = CommentData[4];
+                    InvData.CompleteFlg = (int)InvoiceData.CompleteFlgDef.Printed; 
+
+                    // 請求書データの更新
+                    if (!ioInvData.UpdateAction(strSQL.ToString(), InvData, false)) return false;
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 請求データの削除
+        /// <summary>
+        /// 請求データの削除
+        /// </summary>
+        /// <param name="nInvoiceNo"></param>
+        /// <returns></returns>
+        private bool DeleteInvoiceData(int nInvoiceNo, string strReason)
+        {
+            IOInvoiceData ioInvData = new IOInvoiceData();
+            IORequestHead ioReqHead = new IORequestHead();
+            IORemInvoiceData iORemInvoiceData = new IORemInvoiceData();
+            IORemInvoiceDataDetail iORemInvoiceDetial = new IORemInvoiceDataDetail();
+            bool bDBRollBack = false;
+            string msg = string.Empty;
+            try
+            {
+                ioInvData.connect(); ioInvData.beginTran();
+                ioReqHead.connect(); ioReqHead.beginTran();
+                iORemInvoiceData.connect(); iORemInvoiceData.beginTran();
+                iORemInvoiceDetial.connect(); iORemInvoiceDetial.beginTran();
+
+                StringBuilder sql = new StringBuilder();
+
+                // 請求書削除データ
+                RemInvoiceData remInvoice = new RemInvoiceData();
+                remInvoice.InvoiceNo = nInvoiceNo;
+                remInvoice.RemPerson = CommonMotions.LoginUserData.PersonCode;
+                remInvoice.RemDate = DateTime.Now.Date;
+                remInvoice.RemComment = strReason;
+                if (!iORemInvoiceData.InsertAction(remInvoice, false))
+                {
+                    bDBRollBack = true;
+                    msg = "請求書削除データ登録に失敗しました。";
+                    return false;
+                }
+
+                // 請求書削除明細データ
+                sql.Clear();
+                sql.Append("Select REQUESTNO From Requesthead");
+                sql.AppendFormat(" Where INVOICENO = {0}", nInvoiceNo);
+                sql.Append(" Order By REQUESTNO");
+                ArrayList CodeList = new ArrayList();
+                iORemInvoiceDetial.ExecuteReader(sql.ToString(), ref CodeList, false);
+
+                RemInvoiceDataDetail ReminvDetail = new RemInvoiceDataDetail();
+                int nSeqNo = 1;
+                foreach (object[] objCode in CodeList)
+                {
+                    ReminvDetail.InvoiceNo = nInvoiceNo;
+                    ReminvDetail.SeqNo = nSeqNo++;
+                    ReminvDetail.RequestNo = CommonMotions.cnvInt(objCode[0]);
+                    if (!iORemInvoiceDetial.InsertAction(ReminvDetail, false))
+                    {
+                        bDBRollBack = true;
+                        msg = "請求書削除明細データ登録に失敗しました。";
+                        return false;
+                    }
+                }
+
+                // 請求書データの削除
+                sql.Clear();
+                sql.Append("Update invoicedata");
+                sql.AppendFormat(" Set COMPLETEFLG = {0}", (int)InvoiceData.CompleteFlgDef.Deleted);
+                sql.AppendFormat(ioInvData.CreatePrimarykeyString(nInvoiceNo));
+                if (!ioInvData.ExecuteNonQuery(sql.ToString(), false))
+                {
+                    bDBRollBack = true;
+                    msg = "請求書データ削除に失敗しました。";
+                    return false;
+                }
+
+                sql.Clear();
+                sql.Append("Update requesthead");
+                sql.Append(" Set INVOICENO = 0");
+                sql.AppendFormat(" Where INVOICENO = {0}", nInvoiceNo);
+                if (!ioReqHead.ExecuteNonQuery(sql.ToString(), false))
+                {
+                    bDBRollBack = true;
+                    msg = "請求ヘッダーデータ更新に失敗しました。";
+                    return false;
+                }
+
+                ioInvData.commit();
+                ioReqHead.commit();
+                iORemInvoiceData.commit();
+                iORemInvoiceDetial.commit();
+
+                return true;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                bDBRollBack = true;
+                return false;
+            }
+            finally
+            {
+                if (bDBRollBack)
+                {
+                    ioInvData.rollback();
+                    ioReqHead.rollback();
+                    iORemInvoiceData.rollback();
+                    iORemInvoiceDetial.rollback();
+                }
+
+                ioInvData.close(); ioInvData = null;
+                ioReqHead.close(); ioReqHead = null;
+                iORemInvoiceData.close(); iORemInvoiceData = null;
+                iORemInvoiceDetial.close(); iORemInvoiceDetial = null;
+
+                if (msg.Length > 0)
+                {
+                    MessageBox.Show(msg, "削除エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                }
+            }
+
+        }
+        #endregion
+
+        #region 作成チェック処理
+        /// <summary>
+        /// 作成チェック処理
+        /// </summary>
+        private bool GenerateCheck()
+        {
+            try
+            {
+                int ret;
+                string msg = string.Empty;
+
+                // 作成チェック
+                ret = CheckGenerate(ref msg);
+                bool bError = false;
+                switch (ret)
+                {
+                    case (int)CheckState.Ok:
+                        if (MessageBox.Show(msg, "登録確認"
+                                , MessageBoxButtons.YesNo
+                                , MessageBoxIcon.Question) != DialogResult.Yes) return false;
+                        break;
+                    case (int)CheckState.Warning:
+                        if (MessageBox.Show(msg, "登録確認"
+                                , MessageBoxButtons.YesNo
+                                , MessageBoxIcon.Warning) != DialogResult.Yes) return false;
+                        break;
+                    default:
+                        MessageBox.Show(msg, "登録確認", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        bError = true;
+                        break;
+                }
+                if (bError) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 印刷実行
+        /// <summary>
+        /// 印刷実行
+        /// </summary>
+        private void EntryPrintProc()
+        {
+            FrmSaveFilePath frm = new FrmSaveFilePath();
+            FrmRequestPrint frmPrint = new FrmRequestPrint();
+            IOInvoiceData ioInvData = new IOInvoiceData();
+            IORequestHead ioReqHead = new IORequestHead();
+            IORequestData ioReqData = new IORequestData();
+            IOConstructionBaseInfo ioInfo = new IOConstructionBaseInfo();
+            IOConstructionProgressDate ioPrgDate = new IOConstructionProgressDate();
+
+            try
+            {
+                // 作成チェック
+                if (!GenerateCheck()) return;
+
+                // 印刷確認画面へパラメータをセットする
+                SetParaInvoiceData(frmPrint, ioInvData);
+
+                // 印刷確認画面表示
+                DialogResult drRet = frmPrint.ShowDialog();
+                if (drRet == DialogResult.Cancel) return;
+
+                // EXCEL保存時選択
+                if (drRet == DialogResult.No)
+                {
+                    // 保存先を選択する
+                    frm.SaveType = (int)CommonDefine.SaveFileType.ExcelFile;
+                    //frm.ShowInTaskbar = false;
+                    frm.ShowDialog();
+                    if (frm.EndButton == DialogResult.Cancel) return;
+                    m_SelectSaveExcel = frm.SelectPath;
+                }
+
+                // ---------- 印刷画面よりデータ取得
+                //　日付印刷フラグ
+                m_bDatePrintFlg = frmPrint.DatePrintFlg;
+                //　印刷日付
+                m_DatePrintOut = frmPrint.ExcuteDate;
+                // 発注者名
+                m_strOrderersName = frmPrint.OrdersName;
+
+                // データ登録処理
+                if(!EntryData(frmPrint, ioInvData, ioReqHead, ioReqData, ioInfo, ioPrgDate))
+                {
+                    ioInvData.rollback();
+                    ioReqHead.rollback();
+                    ioInfo.rollback();
+                    ioPrgDate.rollback();
+                    return;
+                }
+
+                // 印刷プロセス数取得
+                m_ProcessCount = m_lstReqHead.Count + 5;       // 明細枚数＋ＥＸＣＥＬオブジェクト取得(2)＋表紙(2)＋一覧(1)
+                PrintProgress.Visible = true;
+                PrintProgress.Minimum = 0;
+                PrintProgress.Maximum = m_ProcessCount;
+                PrintProgress.Value = 0;
+                panel1.Update();
+
+                m_Canceled = false;
+                // ボタンの変更
+                PrintButtonVisbleControl(true);
+
+                //印刷を別スレッドで実行する
+                m_ProgressCount = 0;
+
+                // 印刷・保存の判定フラグ
+                object[] obj = new object[1];
+                if (drRet == DialogResult.Yes) obj[0] = true;
+                else obj[0] = false;
+
+                workerThread = new Thread(new ParameterizedThreadStart(PrintMain));
+                workerThread.IsBackground = true;
+                workerThread.Start(obj);
+
+                // データ表示
+                DispGridData();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                ioInvData.close(); ioInvData = null;
+                ioReqHead.close(); ioReqHead = null;
+                ioReqData.close(); ioReqData = null;
+                ioInfo.close(); ioInfo = null;
+                ioPrgDate.close(); ioPrgDate = null;
+
+                frmPrint.Dispose(); frmPrint = null;
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
+        #region データ登録処理
+        /// <summary>
+        /// データ登録処理
+        /// </summary>
+        /// <returns></returns>
+        private bool EntryData(FrmRequestPrint frmPrint
+                                , IOInvoiceData ioInvData
+                                , IORequestHead ioReqHead
+                                , IORequestData ioReqData
+                                , IOConstructionBaseInfo ioInfo
+                                , IOConstructionProgressDate ioPrgDate)
+        {
+            try
+            {
+                // DBトランザクション開始
+                ioInvData.connect(); ioInvData.beginTran();
+                ioReqHead.connect(); ioReqHead.beginTran();
+                ioReqData.connect(); ioReqData.beginTran();
+                ioInfo.connect(); ioInfo.beginTran();
+                ioPrgDate.connect(); ioPrgDate.beginTran();
+
+                // 請求書作成処理
+                // データの登録
+                if (!EntryPrintData(ioInvData, ioReqHead, frmPrint.CommentData))
+                {
+                    ioInvData.rollback();
+                    ioReqHead.rollback();
+                    ioReqData.rollback();
+                    ioInfo.rollback();
+                    ioPrgDate.rollback();
+                    return false;
+                }
+
+                // 印刷データ取得処理
+                if (!GetPrintData(ioInvData, ioReqHead, ioReqData)) return false;
+
+                // 工事基本情報を更新する
+                if (!UpdateConstructionBaseInfo(ioInfo, ioPrgDate))
+                {
+                    ioInvData.rollback();
+                    ioReqHead.rollback();
+                    ioReqData.rollback();
+                    ioInfo.rollback();
+                    ioPrgDate.rollback();
+                    return false;
+                }
+
+                ioInvData.commit();
+                ioReqHead.commit();
+                ioReqData.commit();
+                ioInfo.commit();
+                ioPrgDate.commit();
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 印刷確認画面へパラメータをセットする
+        /// <summary>
+        /// 印刷確認画面へパラメータをセットする
+        /// </summary>
+        private void SetParaInvoiceData(FrmRequestPrint frmPrint, IOInvoiceData ioInvData)
+        {
+            try
+            {
+                frmPrint.OrdersName = lbOrderersName.Text;
+                frmPrint.ExcuteDate = DateTime.Today.Date;
+
+                int nInvoiceNo = GetSelInvoiceNo();
+                if (nInvoiceNo < 1) return;
+
+                StringBuilder strSQL = new StringBuilder();
+                strSQL.Append(ioInvData.CreatePrimarykeyString(nInvoiceNo));
+                InvoiceData IRec = new InvoiceData();
+                if (!ioInvData.SelectAction(strSQL.ToString(), ref IRec)) return;
+
+                frmPrint.OrdersName = IRec.RequestName;
+                frmPrint.CommentData[0]= IRec.Comment1;
+                frmPrint.CommentData[1] = IRec.Comment2;
+                frmPrint.CommentData[2] = IRec.Comment3;
+                frmPrint.CommentData[3] = IRec.Comment4;
+                frmPrint.CommentData[4] = IRec.Comment5;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 印刷データ取得処理
+        /// <summary>
+        /// 印刷データ取得処理
+        /// </summary>
+        /// <returns></returns>
+        private bool GetPrintData(IOInvoiceData ioInvData
+                                    , IORequestHead ioReqHead
+                                    , IORequestData ioReqData)
+        {
+            try
+            {
+                bool bRet = true;
+
+                List<RequestHead> lstReqHead = new List<RequestHead>();
+                // 請求書データの取得
+                if (!GetInvoiceData(ioInvData, ioReqHead, ioReqData, ref lstReqHead)) return false;
+
+                // 本工事の工事情報の取得
+                if (!GetMainConstructionBaseInfo(lstReqHead)) return false;
+
+                return bRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 請求金額退避エリア
+        /// <summary>
+        /// 請求金額退避エリア
+        /// </summary>
+        private long m_lTotalAmount = 0;    // 合計金額
+        private long m_lTaxAmount = 0;      // 合計税金
+        #endregion
+
+        #region 請求書データの取得
+        /// <summary>
+        /// 請求書データの取得
+        /// </summary>
+        private bool GetInvoiceData(IOInvoiceData ioInvData
+                                    , IORequestHead ioReqHead
+                                    , IORequestData ioReqData
+                                    , ref List<RequestHead> lstReqHead)
+        {
+            try
+            {
+                StringBuilder sql = new StringBuilder();
+
+                // 請求書データの取得
+                sql.Append(ioInvData.CreatePrimarykeyString(m_nInvoiceNo));
+                if (!ioInvData.SelectAction(sql.ToString(), ref m_InvData, false)) return false;
+
+                // 請求ヘッダの取得
+                sql.Clear();
+                sql.AppendFormat(" WHERE InvoiceNo = {0} ORDER BY ReqConstructionCode", m_nInvoiceNo);
+                if (!ioReqHead.SelectAction(sql.ToString(), ref lstReqHead, false)) return false;
+
+                m_dicReqData.Clear();
+                foreach (RequestHead ReqHead in lstReqHead)
+                {
+                    // 請求ヘッダの取得
+                    sql.Clear();
+                    sql.AppendFormat(" WHERE RequestNo = {0} ORDER BY MainConstructionCode", ReqHead.RequestNo);
+                    List<RequestData> lstReqData = new List<RequestData>();
+                    if (!ioReqData.SelectAction(sql.ToString(), ref lstReqData, false)) return false;
+
+                    m_dicReqData.Add(ReqHead.RequestNo, lstReqData);
+
+                    // 請求金額集計
+                    //m_lTotalAmount += ReqHead.RequestTotalAmount;
+                    //m_lTaxAmount += ReqHead.TaxAmount;
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+
+                return false;
+            }
+        }
+        #endregion
+
+        #region 工事基本情報の追加
+        /// <summary>
+        /// 工事基本情報の追加
+        /// </summary>
+        /// <param name="Info"></param>
+        private void AddConstructionBaseInfoDic(ConstructionBaseInfo Info)
+        {
+            if (!m_dicConstructionBaseInfo.TryGetValue(Info.ConstructionCode, out ConstructionBaseInfo wrk))
+            {
+                m_dicConstructionBaseInfo.Add(Info.ConstructionCode, Info);
+            }
+        }
+        #endregion
+
+        #region 工事基本情報の取得
+        /// <summary>
+        /// 工事基本情報の取得
+        /// </summary>
+        private bool GetMainConstructionBaseInfo(List<RequestHead> lstReqHead)
+        {
+            IOConstructionBaseInfo ioInfo = new IOConstructionBaseInfo();
+            try
+            {
+                m_dicConstructionBaseInfo.Clear();
+                StringBuilder sql = new StringBuilder();
+                foreach (RequestHead ReqHead in lstReqHead)
+                {
+                    sql.Clear();
+                    sql.Append(ioInfo.CreatePrimarykeyString(ReqHead.ReqConstructionCode));
+                    ConstructionBaseInfo info = new ConstructionBaseInfo();
+                    if (!ioInfo.SelectAction(sql.ToString(), ref info)) return false;
+
+                    AddConstructionBaseInfoDic(info);
+                }
+
+                List<int> lstKey = new List<int>(m_dicReqData.Keys);
+                foreach (int nRequestNo in lstKey)
+                {
+                    List<RequestData> lstReqData = null;
+
+                    if (!m_dicReqData.TryGetValue(nRequestNo, out lstReqData)) return false;
+
+                    foreach (RequestData ReqData in lstReqData)
+                    {
+                        sql.Clear();
+                        sql.Append(ioInfo.CreatePrimarykeyString(ReqData.MainConstructionCode));
+                        ConstructionBaseInfo info = new ConstructionBaseInfo();
+                        if (!ioInfo.SelectAction(sql.ToString(), ref info)) return false;
+
+                        AddConstructionBaseInfoDic(info);
+                    }
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ioInfo.close(); ioInfo = null;
+            }
+
+        }
+        #endregion
+
+        #region 工事データ更新
+        /// <summary>
+        /// 工事基本情報を更新する
+        /// </summary>
+        /// <returns></returns>
+        private bool UpdateConstructionBaseInfo(IOConstructionBaseInfo ioInfo
+                                                ,IOConstructionProgressDate ioPrgDate)
+        {
+            try
+            {
+                List<int> lstKeyInfo = new List<int>(m_dicConstructionBaseInfo.Keys);
+                Dictionary<int, int> dicCodeWork = new Dictionary<int, int>();
+
+                StringBuilder sql = new StringBuilder();
+
+                foreach (int nConstructionCode in lstKeyInfo)
+                {
+                    // 工事基本情報の取得
+                    if (!m_dicConstructionBaseInfo.TryGetValue(nConstructionCode, out ConstructionBaseInfo Info)) return false;
+
+                    int nOldStatus = Info.ConstructionStatusFlg;
+
+                    // 工事状態が「請求準備」ではない場合は対象外
+                    if (nOldStatus != (int)CommonDefine.StatNumArray.Status9) continue;
+
+                    // 工事基本情報で請求一括でない場合は対象外
+                    if (Info.BillingSplitFlg != (int)ConstructionBaseInfo.BillingSplitFlgDef.AllOnBilling) continue;
+
+                    // 工事状態フラグを「請求確認」に変更
+                    Info.ConstructionStatusFlg = (int)CommonDefine.StatNumArray.Status10;
+
+                    // 請求日セット
+                    Info.BillingDate = m_DatePrintOut;
+
+                    // 工事基本情報を更新
+                    sql.Clear();
+                    sql.Append(ioInfo.CreatePrimarykeyString(nConstructionCode));
+                    if (!ioInfo.UpdateAction(sql.ToString(), Info, false)) return false;
+
+                    // 既にデータが存在しないか一度検索しておく
+                    sql.Clear();
+                    sql.Append(ioPrgDate.CreatePrimarykeyString(nConstructionCode));
+                    sql.AppendFormat(" And ConstructionStatusFlg = {0}", Info.ConstructionStatusFlg);
+                    List<ConstructionProgressDate> lstPrgDate = new List<ConstructionProgressDate>();
+                    if (!ioPrgDate.SelectAction(sql.ToString(), ref lstPrgDate, false)) return false;
+
+                    // データがある場合は、当該データを削除する
+                    if (lstPrgDate.Count > 0)
+                    {
+                        // 該当データを削除
+                        sql.Clear();
+                        sql.Append(ioPrgDate.CreatePrimarykeyString(nConstructionCode));
+                        sql.AppendFormat(" And ConstructionStatusFlg = {0}", Info.ConstructionStatusFlg);
+                        if (!ioPrgDate.DeleteAction(sql.ToString(), false)) return false;
+                    }
+
+                    // 案件進捗日付データの構築
+                    ConstructionProgressDate PrgDate = new ConstructionProgressDate();
+
+                    // 案件進捗日付データの設定
+                    PrgDate.ConstructionCode = nConstructionCode;
+                    PrgDate.ConstructionStatusFlg = (int)CommonDefine.StatNumArray.Status10;
+                    PrgDate.PreviousStatusFlg = nOldStatus;
+                    PrgDate.ChangeDate = DateTime.Now;
+                    PrgDate.ChangePersonCode = CommonMotions.LoginUserData.PersonCode;
+
+                    // 案件進捗日付データを挿入
+                    if (!ioPrgDate.InsertAction(PrgDate, false)) return false;
+
+                    // 対象工事が結合（子）工事の場合
+                    if (Info.JoinFlg == (int)ConstructionBaseInfo.JoinFlgDef.JoinChildren)
+                    {
+                        // 結合（親）工事番号の取得
+                        int nParentCode = GetJoinParentConstructionCode(nConstructionCode);
+
+                        int nChildCode = 0;
+
+                        // 親工事番号が登録されていない場合は登録する
+                        if (!dicCodeWork.TryGetValue(nParentCode, out nChildCode))
+                        {
+                            // 結合（親）の工事状態を更新するために工事番号を退避
+                            dicCodeWork.Add(nParentCode, nConstructionCode);
+                        }
+                    }
+                }
+
+                List<int> lstKeyLink = new List<int>(dicCodeWork.Keys);
+
+                foreach (int nParentCode in lstKeyLink)
+                {
+                    if (dicCodeWork.TryGetValue(nParentCode, out int nChildCode))
+                    {
+                        // 結合（親）の工事状態を変更
+                        ClsChangeBaseInfoData.SetParentConstrStatus(ioInfo, nChildCode);
+                    }
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 同一請求書番号一括チェック処理
+        /// <summary>
+        /// 同一請求書番号一括チェック処理
+        /// </summary>
+        private void CheckBoxGroupOn()
+        {
+            try
+            {
+                dgv1.EndEdit();
+                int nCurRowIndex = dgv1.CurrentRow.Index;
+                int CurRowBillNo = CommonMotions.cnvInt(dgv1.CurrentRow.Cells[(int)DispColumn.InvoiceNo].Value);
+                bool bCurRowChk = CommonMotions.cnvBool(dgv1.CurrentRow.Cells[(int)DispColumn.CheckFlg].Value);
+
+                // 請求書番号件数チェック
+                foreach (DataGridViewRow CheckRow in dgv1.Rows)
+                {
+                    // 自行は処理しない
+                    if (CheckRow.Index == nCurRowIndex) continue;
+
+                    int nBillNo = CommonMotions.cnvInt(CheckRow.Cells[(int)DispColumn.InvoiceNo].Value);
+                    // 番号無は処理しない
+                    if (nBillNo < 1) continue;
+                    // 番号違いは処理しない
+                    if (nBillNo != CurRowBillNo) continue;
+
+                    // 選択行と同じ状態にするOnならばOff
+                    CheckRow.Cells[(int)DispColumn.CheckFlg].Value = bCurRowChk;
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 請求書番号つきデータの複数選択チェック
+        /// <summary>
+        /// 請求書番号つきデータの複数選択チェック
+        /// </summary>
+        /// <returns></returns>
+        private bool BillingNoMulitiCheck()
+        {
+            try
+            {
+                // 請求書番号件数チェック
+                List<int> BillNoList = new List<int>();
+                foreach (DataGridViewRow CurRow in dgv1.Rows)
+                {
+                    // 選択無しは対象外
+                    bool bCurRowChk = CommonMotions.cnvBool(CurRow.Cells[(int)DispColumn.CheckFlg].Value);
+                    if (!bCurRowChk) continue;
+
+                    // 未印刷は対象外
+                    int nBillNo = CommonMotions.cnvInt(CurRow.Cells[(int)DispColumn.InvoiceNo].Value);
+                    if (nBillNo < 1) continue;
+
+                    // 既に追加済みかを検索する
+                    bool bMatch = false;
+                    foreach(int nNo in BillNoList)
+                    {
+                        if (nBillNo == nNo)
+                        {
+                            bMatch = true;
+                            break;
+                        }
+                    }
+                    if (bMatch) continue;
+
+                    // 対象リストへ追加
+                    BillNoList.Add(nBillNo);
+                }
+                // 複数あればエラー
+                if (BillNoList.Count > 1) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 選択データより請求書番号取得
+        /// <summary>
+        /// 選択データより請求書番号取得
+        /// </summary>
+        /// <returns></returns>
+        private int GetSelInvoiceNo()
+        {
+            try
+            {
+                // 請求書番号取得
+                int nBillNo = 0;
+                foreach (DataGridViewRow CurRow in dgv1.Rows)
+                {
+                    nBillNo = CommonMotions.cnvInt(CurRow.Cells[(int)DispColumn.InvoiceNo].Value);
+                    if (nBillNo < 1) continue;
+
+                    bool bCurRowChk = CommonMotions.cnvBool(CurRow.Cells[(int)DispColumn.CheckFlg].Value);
+                    if (!bCurRowChk) continue;
+
+                    break;
+                }
+
+                return nBillNo;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return -1;
+            }
+        }
+        #endregion
+
+        #region 請求データ取消処理
+        /// <summary>
+        /// 請求データ取消処理
+        /// </summary>
+        private void InvoiceRemoveProc()
+        {
+            FrmCancelInvoice frm = new FrmCancelInvoice();
+            try
+            {
+                // 請求書番号つきデータの複数選択チェック
+                if (!BillingNoMulitiCheck())
+                {
+                    MessageBox.Show("複数請求書を選択しています。"
+                                    , "選択エラー"
+                                    , MessageBoxButtons.YesNo
+                                    , MessageBoxIcon.Information);
+                    return;
+                }
+
+                int nInvoiceNo = GetSelInvoiceNo();
+                
+                // 取消理由入力
+                frm.InvoiceNo = nInvoiceNo;
+                frm.ExecuteSubFlg = m_ExecuteSubFlg;
+                if (frm.ShowDialog() == DialogResult.Cancel) return;
+                string strReason = frm.Reason;
+
+                if (MessageBox.Show("選択されている請求書を取り消しますがよろしいですか？", "削除確認"
+                                        , MessageBoxButtons.YesNo
+                                        , MessageBoxIcon.Information) == DialogResult.No)
+                {
+                    return;
+                }
+
+                // 請求書データの削除
+                if (!DeleteInvoiceData(nInvoiceNo, strReason)) return;
+
+                // データ表示
+                DispGridData();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose();frm = null;
+            }
+        }
+        #endregion
+    }
+}
